library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity TPCtl_demo is
  port(
    clk : in std_logic;
    rst : in std_logic;
    PENIRQ_I : in std_logic;
    CS_O : out std_logic;
    DIN_O : out std_logic;
    DOUT_I : in std_logic;
--    BUSY_I : in std_logic;
    DCLK_O : out std_logic;
    SEG : out std_logic_vector(7 downto 0);
    AN : out std_logic_vector(3 downto 0);
    SW : in std_logic_vector(1 downto 0)
    );
end;

architecture func of TPCtl_demo is

  component TPCtl
    Port (
      CLK_I : in STD_LOGIC;
      RST_I : in STD_LOGIC;
      X_O : out STD_LOGIC_VECTOR(11 downto 0);
      Y_O : out STD_LOGIC_VECTOR(11 downto 0);
      Z_O : out STD_LOGIC_VECTOR(11 downto 0);
      PENIRQ_I : in STD_LOGIC;
      CS_O : out  STD_LOGIC;
      DIN_O : out  STD_LOGIC;
      DOUT_I : in  STD_LOGIC;
--	BUSY_I : in  STD_LOGIC;
      DCLK_O : out  STD_LOGIC;
      PEN : out std_logic
      );
  end component;

  signal Xcoord : std_logic_vector(11 downto 0);
  signal Ycoord : std_logic_vector(11 downto 0);
  signal Zcoord : std_logic_vector(11 downto 0);    
  signal int_value : std_logic_vector(15 downto 0);
  signal int_PEN : std_logic;
  
  component leddriver
     port(
       clk,rst : in std_logic;
       seg : out  std_logic_vector(7 downto 0);
       an : out  std_logic_vector(3 downto 0);
       value : in  std_logic_vector(15 downto 0)
       );
   end component;

begin

  Inst_TPCtl : TPCtl
    port map(
      CLK_I => clk,
      RST_I => rst,
      X_O => Xcoord,
      Y_O => Ycoord,
      Z_O => Zcoord,
      PENIRQ_I => PENIRQ_I,
      CS_O => CS_O,
      DIN_O => DIN_O,
      DOUT_I => DOUT_I,
      DCLK_O => DCLK_O,
      PEN => int_PEN
      );


  Inst_leddriver : leddriver
    port map(
      clk => clk,
      rst => rst,
      seg => SEG,
      an => AN,
      value => int_value
     );

  int_value <= "0000" & Xcoord when SW = "00" else
               "0000" & Ycoord when SW = "01" else
               "0000" & Zcoord when SW = "10" else
--               "000000000000000" & int_PEN when SW = "10" else
               Xcoord(11 downto 4) & Ycoord(11 downto 4);

--int_value <= "0000" & Xcoord;
--int_value <= "0000" & Ycoord;
--int_value <= "0000" & Zcoord;     
  

end architecture;
